
#ifndef _CSFFONT_H
  #define _CSFFONT_H

  #include "mir.h"
  #include "car.h"
  #include "csf.h"

  #include <stdlib.h>

//  extern TCSF *CSF_new (int pak_handle, const char *fontName);
//  extern void CSF_delete (TCSF *fnt);
//  extern void CSF_setPal (TCSF *fnt, TRGBColor *colors, int firstColor, int numColors);
//  extern void CSF_updateColors (TCSF *fnt, TRGBColor *pal, int baseColor = 2, int palLen = 254);
//  extern int CSF_changeBaseColor (TCSF *fnt, long newBaseColor);
  extern void CSF_print (TCSF *fnt, const char *text, int x, int y);
  extern void CSF_putChar (TCSF *fnt, char c, int x, int y, int type); // = 0
  extern void CSF_cpyText (TCSF *fnt, const char *text, void *dst,
			int x, int y, int sizeX, int sizeY);

  extern int CSF_getSizeX (TCSF *fnt);
  extern int CSF_getSizeY (TCSF *fnt);
  extern int CSF_getTextLength (TCSF *fnt, int charsTotal);
  extern int CSF_getTextWidth (TCSF *fnt, int linesTotal);
  extern int CSF_getTextSize (TCSF *fnt, int charsTotal, int linesTotal);
  extern void *CSF_char (TCSF *csf, int c);
//  extern void *CSF_raw (TCSF *fnt, int c);

  extern void CSF_setXSpacing (TCSF *fnt, int newXSpacing);
  extern void CSF_setYSpacing (TCSF *fnt, int newYSpacing);

  extern void CSF_getTextBufSize (char *textBuf, int *sizeX, int *sizeY, TCSF *fnt); // = NULL

  extern short *CSF_createMapBuffer (int sizeX, int sizeY, int tileX, int tileY, int *mapLenX, int *mapLenY);
  extern char *CSF_createSprBuffer (char *raw, int sizeX, int sizeY, int tileX, int tileY);

  extern short *CSF_createTextMapBuffer (char *textBuf, int textSizeX, int textSizeY);
  extern char *CSF_createTextSprBuffer (TCSF *fnt);

  extern char *CSF_createTextBuf (TCAR *carHandle, const char *fileName);
  extern TMIR *CSF_newMirror (TCSF *fnt, int charsTotal, int linesTotal);

#endif
