
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <mem.h>

#include "cgdk.h"
#include "svga.h"
#include "pal.h"
#include "timer.h"
#include "keyb.h"
#include "csf.h"
#include "pal.h"

int main (void)
{
  int i, j;
  int sizeX;
  int sizeY;
  TCSF *b1, *b2;
  TCAR *carHandle;
  char *buf;

  TRGBColor pal [256] = {0};
  TRGBColor pal1 [256] = {0};
  TRGBColor pal2 [256] = {0};

  SVGA_enableVESA = 1;

  printf ("\n"
	   "Predmet PZ - demostrace obvodu VGA\n");

	 // we first initialize CGDK using function CGDK_init to enable detection of
	 // supported video modes using SVGA_videoModeSupported function

    CGDK_init ();
    // call this function to use CGDK enhanced keyboard driver.
    // note that all standard console c/c++ functions will not work
    // until you call KEYB_done
    KEYB_init ();

    // do not forget to call this function AFTER installing your
    // sound system drivers and/or other program libraries,
    // otherwise, the program will hang-up !
//    TIMER_init (TIMER_OLDFREQ_DEF);

    SVGA_setVideoMode (XVGA_320x200x256 + NO_SCROLL);

    carHandle = CAR_open (CAR_EMULATION);

    b1 = CSF_new (carHandle, "1.csf");

    PAL_get (pal, 0, 16);
    CSF_updateColors (b1, pal, 16, 200);
    PAL_set (pal+16, 16, 200);

    sizeX = SVGA_maxX / 4;
    sizeY = SVGA_maxY / 4;

    buf = (char *) malloc (sizeX * sizeY);

    for (i = 0; i < 4; i++)
    {
      for (j = 0; j < 4; j++)
      {
	memset (buf, j + i*4, sizeX * sizeY);
	SVGA_putWinNoVSB (buf, j * sizeX, i * sizeY, sizeX, sizeY, sizeX);
      }
    }

    for (i = 0; i < 100; i++)
    {
      SVGA_putPixelNoVSB (100, 50 +i, 0);
      SVGA_putPixelNoVSB (50 + i, 100, 0);
    }

    KEYB_wait ();

    SVGA_putWinNoVSB (b1->raw,
		     (SVGA_maxX - b1->sizeX)/2, (SVGA_maxY - b1->sizeY)/2,
		     b1->sizeX, b1->sizeY, b1->sizeX);

    KEYB_wait ();

    memcpy (pal2, pal, sizeof pal);
    memcpy (pal1, pal, sizeof pal);

    PAL_fadeOut (NULL, 100, 0, 256);
    PAL_fadeIn (pal, 100, 0, 256);

    KEYB_wait ();

    for (i = 0; i < 256; i++)
      pal1 [i].r = 0;

    PAL_mix (pal, pal1, 100 , 0, 256);

    KEYB_wait ();

    for (i = 0; i < 256; i++)
      pal2 [i].g = pal2 [i].b = 0;

    PAL_mix (pal1, pal2, 100 , 0, 256);

    KEYB_wait ();

    PAL_mix (pal2, pal, 100, 0, 256);

    PAL_fadeAway (NULL, 100, 0, 256);

    SVGA_done ();

  return 0;
}
