
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <mem.h>

#include "svga.h"
#include "pal.h"
#include "flic.h"
#include "cgdk.h"
#include "timer.h"

TRGBColor *FLICP_pal;
static char far *FLICP_buf;
static int FLICP_sizeX,FLICP_sizeY;
static int FLICP_x,FLICP_y;
static int FLICP_ticks;

int FLICP_init (TCAR *carHandle, const char *fileName, int x, int y)
{
  int sizeX,sizeY;

  FLICP_done ();

  FLICP_ticks = 0;
  if ((FLIC_getInfo (carHandle, fileName, &FLICP_sizeX, &FLICP_sizeY) == 0))
  {
    if (SVGA_linearBuf == NULL)
    {
      sizeX = FLICP_sizeX;
      sizeY = FLICP_sizeY;
      FLICP_buf = (char far *) _alloc ((unsigned)(sizeX*sizeY));
      if (FLICP_buf == NULL)
      {
        return -1;
      }
    }
    else
    {
      sizeX = SVGA_virtualX;
      sizeY = SVGA_virtualY;
      FLICP_buf = (char far *) SVGA_linearBuf;
    }
    FLICP_pal = (TRGBColor *) _calloc (256, sizeof (TRGBColor),NULL);
    if (FLICP_pal == NULL)
    {
      return -1;
    }
    FLICP_x = y;
    FLICP_y = y;
    if (FLIC_load (carHandle, fileName, FLICP_buf+x+y*SVGA_virtualX,
        sizeX, sizeY, FLICP_pal) == 0)
    {
      return 0;
    }
    else
    {
      return -1;
    }
  }
  return -1;
}

void FLICP_done (void)
{
  if (SVGA_linearBuf == NULL)
  {
    if (FLICP_buf != NULL)
    {
      _free ((void *) FLICP_buf);
      FLICP_buf = NULL;
    }
  }
  if (FLICP_pal != NULL)
  {
    _free (FLICP_pal);
    FLICP_pal = NULL;
  }
  FLIC_unload ();
}

void FLICP_play (void)
{
  FLIC_play ();
  while ( (TIMER_timeTotal - FLICP_ticks) < FLIC_delay)
  {
    SVGA_wait (1);
  }
  FLICP_ticks = TIMER_timeTotal;

  PAL_set (FLICP_pal, 0, 256);
  if (SVGA_linearBuf == NULL)
  {
    SVGA_putWinNoVSB ((void *)FLICP_buf, FLICP_x, FLICP_y, FLICP_sizeX, FLICP_sizeY, FLICP_sizeX);
  }
}
