
#include <stdio.h>
#include <dos.h>
#include <string.h>

#include "lzw.h"
#include "cgdk.h"

#define INPUT_STRING "ababcababaaaaaaa"

static char inputBuf [] = INPUT_STRING;

// compressed lzw buffer should have length at least 2 times then uncompressed buffer
static char lzwBuf [2*sizeof inputBuf];

static char outputBuf [sizeof inputBuf];

int main (void)
{
  long len;

  LZW_init ();

  printf ("\n"
	  "LZWM - example lzw memory compressor\n"
	  "\n%s\n", CGDK_copyright);

  memset (outputBuf, 'x', sizeof outputBuf);

  printf ("Source memory length       : %li\n", (long) sizeof inputBuf);
  printf ("Source string              : %s\n\n", inputBuf);

  len = LZWM_compress (inputBuf, sizeof inputBuf, lzwBuf);

  if (len == 0)
  {
    CGDK_exit ("Not enough memory for lzw structure.\n", 1);
  }

  printf ("Compressed memory length   : %li\n", len);
  printf ("\n");

  len = LZWM_uncompress (lzwBuf, len, outputBuf);

  printf ("Uncompressed memory length : %li\n", len);
  printf ("Uncompressed string        : %s\n", outputBuf);

  return 0;
}
