
#include <mem.h>
#include <stdlib.h>
#include <string.h>

#include "cgdk.h"
#include "svga.h"
#include "keyb.h"
#include "spr.h"
#include "mir.h"
#include "lin.h"

/*
int SPR_updateFixColors (TCSF *spr, TRGBColor *pal)
{
  int baseColor;
  int i;

  if (spr != NULL)
  {
    for (i = 1; i < spr->maxColor; i++)
    {
      if ( *(long *) &spr->colors [i] != 0)
        pal [i] = spr->colors [i];
    }
  }
  return 0;
}
*/



/*
TCSF *SPR_createFix (void *rawBuf, int sizeX, int sizeY, TRGBColor palette [256])
{
  TCSF *spr;
  char curColor;
  long i,j,a;
  unsigned char c;
  char *_rawBuf = (char *) rawBuf;

  spr = (TCSF *) _calloc (sizeof (TCSF), 1 NULL);
  if (spr == NULL)
    return NULL;

  spr->raw = (char *) _calloc (sizeX * sizeY, 1, NULL);
  if (spr->raw == NULL)
  {
    _free (spr);
    return NULL;
  }

  strcpy (spr->desc, CSF_FILEDESC);

  spr->type = CSF_FILETYPE;
  spr->sizeX = sizeX;
  spr->sizeY = sizeY;
  spr->bytesPerPixel = 1;
  spr->count = 1;
  spr->baseColor = 1;
  spr->maxColor = 255;

  if (spr->maxColor != 0)
  {
    spr->colors = (TRGBColor *) _calloc (255*sizeof (TRGBColor),1, NULL);
    if (spr->colors == NULL)
    {
      _free (spr->raw);
      _free (spr);
      return NULL;
    }
  }

  memcpy (spr->raw, rawBuf, sizeX*sizeY);
  for (i = 0; i < sizeX*sizeY; i++)
  {
    c = _rawBuf [i];
    if ( (*(long *)&palette [c] != 0) && ( * (long *) &spr->colors [i] == 0))
    {
      spr->colors [c] = palette [c];
    }
  }
  return spr;
}
*/

void SPR_2timesZoomBuf (char *dstBuf, char *srcBuf, int sizeX, int sizeY)
{
  int i,j;

  for (j = 0; j < sizeY; j++)
  {
    for (i = 0; i < sizeX; i++)
    {
      dstBuf [(2*sizeX)*(2*j)   +2*i   ] =
      dstBuf [(2*sizeX)*(2*j)   +2*i+1 ] =
      dstBuf [(2*sizeX)*(2*j+1) +2*i   ] =
      dstBuf [(2*sizeX)*(2*j+1) +2*i+1 ] =
        srcBuf [j*sizeX+i];
    }
  }
}


char *SPR_2timesZoom (char *buf, int sizeX, int sizeY)
{
  char *newBuf;

  newBuf = (char *) _alloc (4*sizeX*sizeY);
  if (newBuf)
  {
    SPR_2timesZoomBuf (newBuf, buf, sizeX, sizeY);
  }
  return newBuf;
}

char *SPR_4timesZoomBuf (char *dstBuf, char *srcBuf, int sizeX, int sizeY)
{
  char *new2Buf;
  char *new4Buf;

  new2Buf = SPR_2timesZoom (srcBuf, sizeX, sizeY);
  if (new2Buf)
  {
    SPR_2timesZoomBuf (dstBuf, new2Buf, 2*sizeX, 2*sizeY);
    _free (new2Buf);
    return new4Buf;
  }
  else
  {
    return NULL;
  }
}

char *SPR_4timesZoom (char *buf, int sizeX, int sizeY)
{
  char *new4Buf;

  new4Buf = (char *) _alloc (16*sizeX*sizeY);
  if (new4Buf)
  {
    SPR_4timesZoomBuf (new4Buf, buf, sizeX, sizeY);
  }
  return new4Buf;
}


static int SPR_touchHalf (int sx1,int sy1,int sx2,int sy2,
                         int dx1,int dy1,int dx2,int dy2)
{
  return ( (((sx1 >= dx1) && (sx1 <= dx2)) || ((sx2 >= dx1) && (sx2 <= dx2))) &&
     (((sy1 >= dy1) && (sy1 <= dy2)) || ((sy2 >= dy1) && (sy2 <= dy2))) ||
     ((sx1 <= dx1) && (sx2 >= dx2) && (sy1 >= dy1) && (sy2 <= dy2)));
}

int SPR_touch (int sx1,int sy1,int sx2,int sy2,
              int dx1,int dy1,int dx2,int dy2)
{
  return (SPR_touchHalf (sx1, sy1, sx2, sy2, dx1, dy1, dx2, dy2) ||
    (SPR_touchHalf (dx1, dy1, dx2, dy2, sx1, sy1, sx2, sy2)));
}
