
#ifndef _TEXTMODE_H_
  #define _TEXTMODE_H_

  #ifdef __cplusplus
  extern "C" {
  #endif

  #define TM_NOCURSOR 0x2000

  #include "csf.h"

  #define TM_FONT_SHADOW 7

  #define TM_CURSORFREQ_DEF 150 // ms
  #define TM_TEXTFONT_WIDTH 14

  extern int TM_length;
  extern int TM_width;
  extern int TM_clength;
  extern int TM_cwidth;
  extern int TM_csize;

  extern TCSF **TM_font;

  extern void TM_init (void);
  extern void TM_setup (void);
  extern int TM_install (void);
  extern void TM_restore (void);
  extern void TM_done (void);

  extern void TM_getCursorPos (int *X, int *Y);
  extern int TM_getCursorType (void);
  extern void TM_setCursorPos (int X, int Y);
  extern void TM_setCursorType (int Type);
  extern void TM_printChar (char c, unsigned char color, int x, int y, void *backGround); // = NULL
  extern void TM_printBlock (short *buf, int x, int y, int len, int width, void **sprUpdateBuf);
  extern void TM_flush (void);
  extern void TM_setTextFont (char *charTable, unsigned char first,
                       unsigned char count, char width); // = TM_TEXTFONT_WIDTH
  extern void TM_setROMFont (void);

  extern void TM_updateCursor (void);
  extern void TM_setCursor (TCSF *csf, int n, int freq); // = NULL, = 0
  extern int TM_getVGA50Lines (void);
  extern void TM_setVGA50Lines (void);

//  extern void TM_setCursorFreq (int freq=TM_CURSORFREQ_DEF);

  #ifdef __cplusplus
  }
  #endif

#endif
